\chapter{The Linux Kernel Development Model from the FLOSS community perspective}
\label{cap:linuxdevmodel}

The inclusion of GL in systematic literature reviews has been
increasingly widespread in the medical field~\citep{Godin2015,Paez2017}.
However, in software engineering, this procedure is not easily found yet. For
that reason, we relied on guidelines from studies in both
areas~\citep{Soldani2018,Garousi2018,Godin2015,Paez2017} 
to structure a search plan suitable for FLOSS publications.

To address the lack of well-established methods
specifically tailored for exploring grey literature, we adapted the
existing systematic review methods to examine community productions with defined steps and constraints.
Systematic Literature
Review (SLR) is a research methodology that follows rigorous procedures to
synthesize and evaluate the available evidence on a focused
topic~\citep{Biolchini2007}, supporting the development of
evidence-based guidelines for practitioners~\citep{Kitchenham2009}.
Combining SLR methods with GLR helps shed light on important
industrial practices still not mapped by conventional software engineering
studies~\citep{Soldani2018}. 

As with SLRs, the GLR methodological plan provides guidelines, structure, and
transparency to the search methods~\citep{Godin2015}. However, due to grey
materials' characteristics, GLR searches are often less methodical than
traditional systematic searches for academic publications.
The researcher should map data sources and types, search terms, selection
criteria, and boundaries to reduce searching bias. This approach also helps
manage the variety of search terms and the volume and diversity of ``grey''
materials available throughout the web.

Accordingly, this chapter presents the design and application of the systematic
grey literature review on the Linux kernel development model. We highlight the
challenges, specificities, adaptations, and lessons learned from our experience
examining publications from the FLOSS community. This chapter is an extension
of our previous work on defining strategies to examine GL documents of FLOSS
projects~\citep{Wen2020}.

Section~\ref{sec:greylit} describes a set of strategies and guidelines to
support grey literature reviews on FLOSS. Section~\ref{sec:glrresult} presents
a mind map resulting from our content review and analysis strategies to
systematize the concepts that describe the current Linux kernel community
model. Section~\ref{sec:glrdiscussion} explains how the selected documents from
the grey literature provide the concepts outlined in the mind map.

\section{Systematic Grey Literature Review}
\label{sec:greylit}

We present here guidelines for supporting future FLOSS literature reviews.
We mapped challenges and adaptations for GLR on FLOSS and summarized our GLR
flow in Figure ~\ref{fig:GLRflow}. It is a first effort in defining a
methodology for conducting GLRs for software engineering research.

\begin{figure}[ht]
  \centering
    \includegraphics[width=1.0\linewidth]{figure/GLR_WorkFlow.png}
  \caption{Steps of our GLR Flow}
  \label{fig:GLRflow}
\end{figure}

\subsection{GLR Planning}
\label{sec:glrplanning}

The GLR Planning covers four essential steps to ensure the quality of the
selected documents:
\begin{enumerate}
\item Outline the problem and define the research question.
\item Define the inclusion and exclusion criteria.
\item Develop a relaxed search string.
\item Define the resource-types to consider.
\end{enumerate}

Also, we developed and applied additional methods to refine the screening
step and complete the GL search. From an extensive selection of
information sources, we evaluated and selected most relevant data sources.
After, we identified and examined documents using an incremental screening
process. In the following, we describe better the steps of planning GLR on
FLOSS, and conduction of the screening process.

\textbf{Outline the Problem and Define the Research Question.}
%
The first step in a typical GLR planning process is to establish the need for
this type of review. Researchers should then describe the study's background
and objectives in a protocol ~\citep{Cochrane2011} to delimit the scope of
research and define research questions.

The distributed, community-based development of the Linux kernel project
provides a wealth of alternative resources of professionals' information. This
materials examination can ensure the most current picture of the Linux kernel
development model and expand the knowledge on the FLOSS state of practice. For
example, some organizations periodically provide reports about the State of
Linux Kernel Development, which promptly discusses the Linux development
statistics, who is working on the kernel, sponsoring the development, and so
on. In this regard, the research question \textit{``RQ1. How do software engineering studies and Linux community publications describe the current Linux development community model?''} guided our review case. At this phase, we first
examined the perspective of community publications.

\textbf{Define Eligibility Criteria.}
%
Reviewing the GL poses many validity risks since these materials
are not reviewed or provided by traditional publishers and channels. Besides
this, evidence in them is often based on personal experience and opinion, at
the risk of catching fake news and views from people
outside the problem set. Based on the experiences reported by
\citet{Soldani2018} and \citet{Garousi2018}, we recommend defining 
inclusion and exclusion criteria and combining them with additional control
factors to mitigate this problem.

\begin{table}[ht]
\centering
\caption{Grey Literature Review - Eligibility Criteria and Control Factors}
\label{tab:glr_eligibility}
\setlength{\tabcolsep}{12pt}
\renewcommand{\arraystretch}{1.5}
\resizebox{\textwidth}{!}{%
\begin{tabular}{| m{7cm} | m{7cm} |}
	\rowcolor[HTML]{c0d6e4}
	\hline
	Eligibility Criteria 		 & Control Factors \\
	\hline
	Published between 2009 and 2019. & The document is publicly accessible. \\ \hline
	Most current version of the document. &  The content is not centered on: technical issues or specific features. \\ \hline
	Available in English. & \\ \hline
	Published online by institutions, industry-oriented magazines, and  practitioners of the FLOSS area. & Historical facts, statistics, or Linux kernel project artifacts support the statements in the document. \\ \hline
	Describes developments in the Linux kernel by: (1) reporting practices; (2) presenting statistics; (3) discussing management and rules inside the project; (4) or studying the project development and/or its community. & The document is published by: (1) a reputable organization or magazine; (2) an individual author associated with such organizations and magazines, or (3) a practitioner with more than five years of FLOSS experience. \\
	\hline
\end{tabular}%
}
\end{table}

For our review, we selected documents that satisfied the eligibility criteria
and also some control factors to assure sample quality, as presented in
Table~\ref{tab:glr_eligibility}.


\textbf{Develop a Relaxed Search String.}
%
Defining a flexible set of search terms, based on the problem definition and
eligibility criteria, is essential to deal with the variety of terminologies
used by persons and institutions for a given study object, since some popular
keywords in software engineering studies are still not commonly used by
practitioners.
Besides, a GL writer has little concern with standardization and structuring.
Consequently, they usually use more informal and heterogeneous terms. Another
issue is related to applying the search string in a website
search engine. Much of these tools cannot address both diversity and lack of
text structure. Therefore, even with synonyms' prediction, we observed that
broader and simple strings were essential to reach potentially relevant
documents during the search process.
Finally, the diversity of the audience of each data source required a warm-up
round to understand how an organization or person commonly refers to search
string elements and evaluate the coverage of these terms accordingly.

For the Linux project case, we first defined a base search string,
\textit{Linux development model}.
Then, we broke it into words and listed potential synonyms for
each word, as follows:
\begin{enumerate}
\item \textbf{Linux} $\to$ Linux Kernel;
\item \textbf{Development} $\to$ Business, (empty string);
\item \textbf{Model} $\to$ Scheme,  Rules,  Process,  Guide, Community,
Culture, (empty string).
\end{enumerate}


\textbf{Define the Resource-types.}
%
Considering the great diversity of GL resources, list the types of data to be
considered for analysis. Then, separate this data into \textit{in-text content}
and \textit{audiovisual content}, since the latter usually demands more effort
to inspect than the former. Based on the categorization in ``shades of GL''
presented by ~\citet{Adams2017}, rank the resource types according to expected
formality levels. This rank should guide the document review order and support
the development of appropriate stopping criteria for the screening phase.

In our case, we discarded audiovisual resources due to the effort required to
examine this content and the transcription process's difficulty. We also
assessed the expected quality of textual contents from their formality levels.
We decided not to include mailing-list e-mails from this assessment because
these records often have opinion-based discussions. Moreover, in the Linux
kernel project, mailing-list e-mails play dual roles: text and code (artifacts)
community production. Nevertheless, mailing-list e-mails can be an interesting
venue for future research.

%% ------------------------------------------------------------------------- %%
\subsection{Data Collection}
\label{sec:glrcollection}

Even in systematic reviews, changes in a review protocol are sometimes
necessary to adjust methods to unanticipated
circumstances~\citep{Cochrane2011}. Despite all efforts to adhere to the search
plan, we used some strategies to overcome unexpected limitations and
difficulties during document screening.

\subsubsection{Data Source Selection}
%	
In a review of the traditional literature, data source selection
often consists of a set of similar digital libraries from prestigious
organizations in academic computer science publications or similar.
However, for GL of FLOSS projects, data sources are not so obvious,
and selecting them requires specific knowledge and consultation of experts.

A good data source selection minimizes GLR drawbacks such as time spent and
omitting significant evidence.
To select GL suitable data sources for FLOSS studies, the researcher should
carefully consider the initial search string and the content types. We also
recommend four strategies for extensive searching data sources: 

\begin{enumerate}
\item \textbf{Search for targeted source:} Conduct a web search to
identify organization webpages, magazines, and relevant blogs on FLOSS
development. 
Use the advanced search tool to restrict results to English documents only.
In this step, we evaluated the first ten pages
of search hits and manually inspected each website for data source selection.
We also evaluated blog posts that list relevant pages for those
interested in tracking Linux project updates. \\
\item \textbf{Consult experts:} Consultation with experts can help
discover other relevant data sources. We consulted four of them
and identified additional data sources not previously covered. \\
\item \textbf{Apply snowballing:} Add data sources if links or references to
their contents repeatedly appear during the sample selection phase.\\  
\item \textbf{Classify the data sources:} The data sources should be classified
according to their proximity to the object of study, in our case, the Linux
kernel development.
We divided data sources into sources that deal specifically with the Linux
kernel and references that deal more broadly with IT or FLOSS subjects. The
publication collection did not follow any order of priority; however, to
improve the performance of the review process, a researcher should first
evaluate contents in the specific data sources, and use data from the other
sources as complementary information.
\end{enumerate}

Since search engines use unique algorithms to generate their relevance ranking
schemes, the researcher must be prepared to address each data source's
singularities. Accordingly, we recommend a prior evaluation of data sources in
terms of audience, text structure, search tools, quality of search results
display, and updates. This step helps to identify the main subject addressed,
potential search pitfalls, and the formality of documents.

\begin{table}[ht]
\caption{Database evaluation and selection}
\label{tab:glr-data-source}
\setlength{\tabcolsep}{10pt}
\renewcommand{\arraystretch}{1.5}
\resizebox{\textwidth}{!}{%
\begin{tabular}{|l|l|l|c|}
	\hline
	\rowcolor[HTML]{a6cee3}
	Name & Type & Issues & Selected \\ \hline
	wire.com & Magazine & \makecell[l]{Poor search tool \\ Browsing results break after page 10} & No \\\hline
	drdoobs.com & Magazine & Inactive since 2015 & No \\\hline
	linuxformat.com & Magazine & Need payment & No \\\hline
	linux-magazine.com & Magazine & Some contents need payment & No \\\hline
	linuxjournal.com & Magazine & \makecell[l]{The timestamp displayed in the results is not \\ the same of the article publication} & No \\\hline
	linux.com & Tech website & \makecell[l]{Cannot sort by date; no abstract \\ Many hits are only external-publication links} & Yes \\\hline
	linuxfoundation.org & Org website & \makecell[l]{Layout in-grid/block, not in-list \\ No pagination; No option of sort by \\ No filter; No abstract\\Many hits are only external-publication links \\ Some external links are broken\\ Need a google search to find the document} & Yes \\\hline
	cnet.com & Magazine & (not evaluated) & No \\\hline
	networkworld.com & Magazine & \makecell[l]{No regex filter, results is "or" inclusive\\ Too many results; required to sort by relevance \\ Search until page 20} & No \\\hline
	opensourceforu.com & Magazine & \makecell[l]{Search string is "and" by terms\\ Less accuracy of search strings} & No \\\hline
	kernelnewbies.org & Wiki page & \makecell[l]{Good search tools and enable regex \\ ``Linux kernel'' more accurated than ``Linux''} & Yes \\\hline
	lwn.net & News site & \makecell[l]{Search for "and" of terms (no order) or "or"\\ Sort by date; Return only the last 500 publications\\ Articles are written by experts} & Yes \\\hline
	kroah.com & Blog & \makecell[l]{No search tool\\ Manual Inspection} & Yes \\\hline
	blog.ffwll.ch & Blog & \makecell[l]{No search tools, but have tags\\ Manual Inspection +  Tags} & Yes \\\hline
	sage.thesharps.us & Blog & \makecell[l]{Manual inspection + searching for the word "Linux"} & Yes \\ \hline
\end{tabular}%
}
\end{table}

For our review, the mentioned data source search strategies reached 15
data sources: eight magazines, three developer blogs, two practitioners-oriented
news websites, one institutional website, and one wiki page. We evaluated each
of them and discarded one for not allowing open access to publications, as
presented in Table~\ref{tab:glr-data-source}. We flagged two others to receive
proper procedures in the evidence collection and analysis phase. One had a
restricted time interval (it was deactivated in 2015), and the other had its
content only partially screened, as not everything was openly available. 

Some data sources did not provide a search tool, and others had a varying
quality of features. The main issues faced were:
\begin{enumerate}
\item site pagination only worked until page 10;
\item the date of the indexed article in the search was not the same as the date of publication;
\item it was not possible to filter or sort by date;
\item results were shown in blocks rather than lists;
\item there was no pagination;
\item did not present any results ordering;
\item did not allow filter searching;
\item did not enable search by an expression, only search by any of the words of the string;
\item search for all words in the string, but in arbitrary order;
\item limit on the number of documents returned.
\end{enumerate}

To overcome weak search mechanisms, we recommend the following strategies:
\begin{enumerate}
\item \textbf{Choose a suitable order of search hit:} by date, when it is
possible to search by an exact sequence of words; by relevance when the tool
only seeks for any of the terms in the string.\\
\item \textbf{Define stopping criteria} influenced by weak search engines or
large volumes of data, such as page number restriction, a suitable number of
hits, the decline in quality, and availability of evidence.\\
\item \textbf{Consider searching by tags/categories}, whenever possible.
\end{enumerate}

A researcher should perform a manual inspection of publication titles and
dates when a data source does not provide any search engines but had great data
potential (such as some blogs of experienced developers or important
personages).

\subsubsection{Grouping and Screening Phase}

We have developed an incremental method for handling the number of search
hits and the lack of standard indexing. This method consists of
dividing the screening process into data source audiences and iteratively
conducting the sample selection. In each iteration, the inspection becomes more
detailed and follows the ascending order of document formality.

For our review of Linux kernel publications, we separate the selection process
into two, according to data source audience: the most specific Linux source
documents first and then the most widespread for the IT industry. We documented this
screening process in a
spreadsheet\footnote{Data available on \url{gitlab.com/ccsl-usp/glr/-/raw/master/linux-case-data.pdf}}
divided into two tabs: (I) Linux-oriented publishers (8 data sources); and
(II) IT-Industry-oriented publishers (7 data sources).
In the first tab, we identified 236 documents of publishers and practitioners
experts on Linux. In the second tab, we collected 104 documents published in
magazines and blogs of the general IT industry subjects. Each spreadsheet row
represents a potentially relevant document. Seven columns index the document
data: (1) date of last update or access; (2) title; (3) authoring organization
or person; (4) category of the data source; (5) URL; (6) search strategy that
located it; (7) links or references in the document.

\btul{Incremental Screening Process}

After classifying the data sources by their target audience and separating the
documents into two spreadsheets, we started the identification and incremental
screening phase. Two reviewers carried out this phase to mitigate bias issues.
Reviewer 1 is the leading researcher of this work and Reviewer 2 is external
to the investigation but familiar with the object of study. Both have recent
development experiences in the project selected for study.

GL rarely presents standard indexing and controlled vocabulary, with a good
quality title, abstract, or keywords to assist in the document's inclusion or
exclusion. Hence, for this phase, we opted for an incremental exclusion
process. First, remove duplications or documents with only a link for another,
bringing the sample's linked material. Second, try to evaluate titles, looking
for any relation to the object under study.

However, as GL titles are often not accurate or ``attractive'' but misleading,
this process was not very productive.
Because of this, we opted to \textbf{speed read the full-text},
searching for the keyword \textit{Linux} to quickly understand how the project
was addressed in that document and evaluate the exclusion criteria. When the
eligibility criteria were not clear, we kept the document on the list. Finally,
we classified the material according to the categorization of GL
of ~\citet{Adams2017} and performed the full-text screening following this
order of priority: (1) less informal literature first; (2) maintainers blog
posts; (3) reports of project landmarks and emblematic cases; (4) documents
from the snowballing process.

\begin{table}[ht]
\centering
\caption{Number of documents selected per database}
\label{tab:docs_database}
\renewcommand{\arraystretch}{1.5}
\resizebox{0.7\textwidth}{!}{%
\begin{tabular}{|l|l|l|}
\hline
\rowcolor[HTML]{a6cee3}
Database & \# Initial Selection & \# Selected documents \\ \hline
Linux Foundation Website & 77 & 25 \\ \hline
Linux.com & 69 & 40 \\ \hline
LWN.net & 31 & 21 \\ \hline
Digital Magazines & 9 & 3 \\ \hline
Kernel Newbies & 21 & 7 \\ \hline
Members Blog & 29 & 12 \\ \hline
\textbf{Total} & \textbf{236} & \textbf{108} \\ \hline
\end{tabular}%
}
\end{table}

As a result, Table~\ref{tab:docs_database} shows the distribution per database
type of the 108 selected documents that covered topics related to the Linux
kernel community model.

%% ------------------------------------------------------------------------- %%
\subsection{Content Analysis}
\label{sec:glranalysis}

The screening process resulted in the selection of 108 documents. The lack of
standards in text structure and terms used is a visible problem in documents
of this type. Thus, we resort to some strategies to deal with the challenge of
a sample diverse in size, structure, and formality:
\begin{enumerate}
\item We looked at the data from a word cloud structure.
\item Using the same formality classification from the screening process, we
coded the most formal documents (in this case, the foundation's annual reports)
in order of antiquity. We plotted the result in a mind map. With concepts
separated in areas/categories, we verified a poorly characterized area that
needed more depth.
\item Following the formality level strategy, we grouped the documents and
ordered them by recentness to complete the open-coding process.
\end{enumerate}

Below, we detail these strategies and the techniques used in conducting the
grey content analysis.

\subsubsection{The Word Cloud}

To explore the usage of words and content in community publications, we started
the content analysis using a summative technique to identify and quantify the
appearance of words in the textual data from selected documents~\citep{hsieh2005}.
We developed a script to build a word cloud from all selected documents' text
content, searching for familiarity and automatization.
The wordcloud purpose here is to facilitate the familiarization with
community terms, concepts and volume of information. 
The script\footnote{Script available on \url{https://gitlab.com/ccsl-usp/glr/-/blob/master/script_wordcloud.py}}
was developed in Python 3. The script uses a library of natural language
processing named Spacy\footnote{\url{https://spacy.io/}} to tokenize the nouns
and proper nouns. Spacy is open-source software and good for beginners. It
provides pre-trained models for several languages, but, for our sample, we used a
small English model trained on written CNN web text (blogs, news, comments).

\begin{figure}[ht]
  \centering
    \includegraphics[width=0.7\linewidth]{figure/WordCloud_GLR_final.png}
  \caption{WordCloud from Grey Literature textual content}
  \label{fig:GLRcloud}
\end{figure}

We used a word cloud
generator\footnote{\url{https://github.com/amueller/word_cloud}} to count word
frequency, remove stop words and plot the result as a word cloud. With this
visual representation of the text data, we could identify relevant words and
potential core concepts to facilitate the open-coding.
Figure~\ref{fig:GLRcloud} present the automated WordCloud from the raw text of
the 108 selected documents. We can identify words related to the community's
elements, such as the nouns maintainer, developer, people, contributor,
company, behavior, discussion, code of conduct, reviewer, conference; and
prominent proper nouns Linus Torvalds, Greg Kroah, Jonathan Cobert, Linux
Foundation.

We also grouped words related to development artifacts: code, patch (unit of
code changes on a source-code version), source project, device,
repository, documentation, kernel version, source code, lines of code.
The word cloud also reveals process-related codes, such as
merge window, pull request. Finally, some codes characterize the development
and the community structures: subsystem, subsystem tree, subsystem maintainer,
mailing list, email, mainline, role.

Counting the frequency of specific words and visualizing potential core labels
in a word cloud is the initial part of our coding approach. Using a
computer-automated method to reveal the most common and potential concepts
helps avoid bias and misleading information. However, understanding the
contextual use of each uncovered concept also includes the process of content
interpretation. Therefore, after identified patterns in the data, we obtained
potential labels that become the initial coding scheme. The remaining content
analysis used a more conventional approach to discover the range of meanings
that each code presents in the data from this initial coding scheme.

\subsubsection{Open-coding}

Since we are developing strategies to analyze grey literature materials in a
distributed group, we use some online tools to support good documentation of
our open-coding process.

We used online spreadsheets from the Google Docs Editors office suite and kept the data
collected in a single sheet, adding a new column to each new step of both
screening and analysis. We resorted to the feature of ``Suggests'' to document
the coding process, i.e., which words were discarded and how a label was
extracted from a sentence, without excluding any word of the text fragment.
Finally, we developed three versions of the mind map. First, to
become familiar with the data, second, to set up a basis to relate concepts,
and finally, we extended the map to cover all the coding concepts. We used the
Coggle\footnote{\url{https://coggle.it}} platform for mind maps and we chose on
Color Brew\footnote{\url{https://colorbrewer2.org}}, a colorblind safe color
scheme for qualitative data. All figures and mind maps in this
Chapter \ref{cap:linuxdevmodel} and in Chapter \ref{cap:twoperspectives}
subsequent follow the same selected color scheme.

\begin{figure}[ht]
  \centering
    \includegraphics[width=1.0\linewidth]{figure/Linux_general_map.pdf}
  \caption{Grouping concepts from selected documents by subject area}
  \label{fig:first_general_map}
\end{figure}


\begin{table}[ht]
\centering
\caption{Grey scale of publications}
\label{tab:docs_greyscale}
%\resizebox{\textwidth}{!}{%
\begin{tabular}{lll}
	\rowcolor[HTML]{c0d6e4}
	\hline
Grey Scale & Types of Publications              & \# \\ \hline
1          & Project Development Reports    & 4  \\ \hline
2          & Foundation website articles and white papers        & 21 \\ \hline
3          & Magazine and news website articles & 64 \\ \hline
4          & Community Wikipages                & 7  \\ \hline
5          & Blog posts                         & 12 \\ \hline
\end{tabular}%
%}
\end{table}

We organized and grouped codes into meaningful subjects and produced a
conceptual map, considering the initial coding scheme and codes obtained by a
random selection of materials from different formality levels. This conceptual
map revealed what topics are under discussion in the selected community
publications. Figure~\ref{fig:first_general_map} shows four key areas --
Process, Community, Project, Patch -- and a sample of codes related to them. We
observed that many areas present a solid understanding with enough saturation.
The Linux kernel development process is well-documented and systematized in the
project Documentation~\citep{kernel_process}
and other publications with this propose~\citep{linux_corbet}. 
however, concepts concerned with community aspects are scattered around the
documents, lacking systematization. Therefore, we decided to focus on the Linux
kernel community's concepts to build a comprehensive mind map.

We classified the selected documents for levels of formality (greyscale), as
shown by Table~\ref{tab:docs_greyscale}. We started to open-code content from
the four most formal documents - Linux Kernel Development Reports published by
Linux Foundation, ordered by antiquity. We sorted codes into categories and
built a base map version to organize them into a hierarchical structure. From
this, we coded the remaining selected documents and mapped the concepts in
batch. Finally, we define each category, subcategory, and code. We report our
findings in Section~\ref{sec:glrresult}. We also exemplify how code
and category are identified from the data by quoting text fragments. 

%% ------------------------------------------------------------------------- %%
\section{The Linux Kernel Development Community Model}
\label{sec:glrresult}

The strategies just presented in this chapter to conduct GLR on FLOSS answer
\textit{RQ2. What research techniques can be used to examine a FLOSS project through its community publications?}
We analyzed content from selected documents to identify the characteristics
used in community publications to describe the Linux kernel development
community. In this section, we present the results obtained that answer
\textit{RQ1.2. What attributes practitioners use to characterize the Linux development community? What are the current social and organizational challenges from the community perspective?}

Even focusing on one of the meaningful subjects on the Linux kernel community,
we reached an extensive mapping of the community characteristics and critical
elements. Therefore, we narrowed the codes obtained in a mind map of categories to highlight
relevant topics from the community publication perspective that should be
addressed by future FLOSS research.

\begin{figure}[htp]
  \centering
    \includegraphics[width=0.6\linewidth]{figure/Linux_Comunity_Concepts_Fields.pdf}
  \caption{The three fields of the Linux Kernel Community mindmap}
  \label{fig:concepts_field}
\end{figure}

As presented in Figure~\ref{fig:concepts_field}, we sorted the concepts from the grey
literature in a mind map comprising three fields: General Characteristics, Community
Ecosystem, and Community Concerns. This mind map resulted from the exploratory
examining of 108 documents published by practitioners and organizations
inserted in the Linux kernel community. Although we have a vast number of
documents, many are shorter and less-structured than high-level academic papers
and required some expertise and side search for understanding and extracting the
correct knowledge.

\begin{figure}[ht]
  \centering
    \includegraphics[width=0.85\linewidth]{figure/characteristic.png}
  \caption{Mindmap -- Attributes about General Characteristics of the Community}
  \label{fig:feature_map}
\end{figure}

For readability reasons, the entire mind map is available online in a git
respository\footnote{Mindmap available on \url{https://gitlab.com/ccsl-usp/glr/-/blob/master/Linux_KernelDevelopment_Comunity_Categories.pdf}}. Here, we have divided
it into four figures corresponding to the three fields just discussed,
where the Community Ecosystem was subdivided.
General Characteristics are
presented in Figure~\ref{fig:feature_map}, dealing with the community as a whole. The Ecosystem
is presented in two parts: Figure~\ref{fig:ecosystem_map} (companies, foundations, and people) and Figure~\ref{fig:ecosystem_map_2}
(developers, their roles, and organization). Finally, Concerns, as seen in
the selected community publications, are shown in Figure~\ref{fig:concerns_map}.


Figure~\ref{fig:feature_map} describes general characteristics and summarize
transversal features of the Linux kernel community. The community creates a
common project culture. Its participants are organically organized in a
web of trust, supported by features on the git version control tool.
The project development is divided into subsystems or slices
analogous to city neighborhoods. Finally, the project diversity of usage
attracts companies and people from various markets, countries, and cultural
backgrounds.

The remaining figures are shown on the following pages.
Figure~\ref{fig:ecosystem_map} presents three key entities that compose the
Linux kernel development community: companies, people and foundations. Each of
them has a specific interest, and their participation in the community may
influence the development process. Also, the map describes how people in the
community structured themselves according to roles and responsibilities, and
what are their standard means of interaction. Finally, in the sequence of
attributes on the profile of who directly participates in coding
changes, the developers, Figure~\ref{fig:ecosystem_map_2} approach the members'
path into the community, their roles in the work structure, their identity and
affiliation, and their motivation (reasons to stay in the community).

The community publications also expose practitioners' concerns about the
weaknesses of the current project process and management. They commonly express
opinions, questioning the state-of-the-practice and bringing potential solutions for
everyday issues and conflicts. Figure~\ref{fig:concerns_map} depicts what has
bothered the community for the past ten years. They report issues ranging from conduct
norms on communication to scalability weakness on the development process.
These problems may affect the Linux kernel development since developers'
interaction supports project sustainability. Consequently, any
approach to mitigate or overcome difficulties on the collaborative work has the
potential to change the Linux development model, such as maintainership,
hierarchy, grants, and process of review.

\begin{figure}[ht]
  \centering
    \includegraphics[height=1.0\textheight]{figure/ecosystem.png}
	\caption{Mindmap -- Attributes about the Community Ecosystem (1)}
  \label{fig:ecosystem_map}
\end{figure}

\begin{figure}[ht]
  \centering
    \includegraphics[height=1.0\textheight]{figure/ecosystem_developers.png}
	\caption{Mindmap -- Attributes about the Community Ecosystem (2) -- Developers}
  \label{fig:ecosystem_map_2}
\end{figure}


\begin{figure}[ht]
  \centering
    \includegraphics[height=1.0\textheight]{figure/concerns_map.png}
  \caption{Mindmap -- Attributes about Community Concerns}
  \label{fig:concerns_map}
\end{figure}

%% ------------------------------------------------------------------------- %%
\section{Linux Kernel Community Attributes Described by Community Publications}
\label{sec:glrdiscussion}

This section explains how the community claims presented in the 108 documents
analyzed\footnote{All statements made in this section are summaries of the content present in the selected documents. References are available at~\url{https://gitlab.com/ccsl-usp/glr/-/blob/master/GLR_Linux_kernel_development_model.ods}} is connected to each concept presented in the mind maps of the
previous Section~\ref{sec:glrresult}. We strongly recommend that the reader use
the figures referenced in each section to guide the reading of each concept's description.
For a better understanding of what comes next, the concepts were formatted in
the text as follows. Categories are displayed in two levels: as subsections in bold
or underline. We include some text fragments from the
selected documents, in italic and within quotes, to enrich the discussion on the
attributes, some of which are highlighted in bold.

\subsection{General Characteristics}

In the past two decades, the FLOSS ecosystem has diversified its forms of
development. Also, the development of the Linux kernel has undergone notable
transformations. From the governance perspective, the Linux kernel development shows
aspects that diverge from those that inspired an anarchical, bazaar-like model
and converge to dictatorship or a kind of federalism.

Much of the changes in the development of the kernel are a
consequence of the growing \textbf{companies participation}, many of them large
corporations.
\textit{``Corporate participation in free-software development isn't going
away, or, at least, so we must hope. But we have to try not to sell out to it
entirely. A crucial piece of that is not allowing any single company to control
any important project on its own''}~\citep{lwn_linux25}.

The source code and the number of system resources are also growing. As
a consequence, a scalable organization of development work is crucial for the
sustainability of the project. A community of developers does this work, where
the Linux community is seen as the \textbf{FLOSS equivalent of a city}. It
\textbf{grows hugely}, and the source code is \textbf{divided into a number of
neighborhoods} with different levels of friendship between them. As each
neighborhood has its own local rules, many bad experiences happen
because someone crosses over to a new neighborhood and violates one of the
rules.

The pieces of the community interact with each other through a
\textbf{web-of-trust}. The web-of-trust follows a \textbf{flat hierachy}
with a core group of subsystem maintainers and few mid-level maintainers.
The patch flow into the mainline is a good
representation of the maintainers level structure, \textit{``a structure that
is far flatter than the hierarchical maintainer model would suggest. In the
real world, mid-level maintainers are relatively rare; most maintainers send
pull requests directly to Linus
Torvalds.''}~\citep{lwn_patchflow_2017}.
Changes from each subsystem repository is merged into the mainline
following a \textbf{key-signing ritual} to contribution verification.
Subsystem maintainers, responsible for a piece of
the source code, request to merge changes in their repository by signing of
pull-requests. This is supported by a git feature of GPG-sign commits and tags.
This approach aims to improve security and authenticity when merging
repositories, but the community says it is inefficient, as it is not mandatory
and maintainers rarely ask for signatures.

Over time, the community creates a \textbf{project culture} related to commonly
characteristics, expectation and values of members. The intense work of
maintaining the good performance and supporting new features insert
the \textbf{cult of busy} in the community. There is also a certain
\textbf{personality cult}, where high-profiles and maintainers could
cross the line with abusive performance. This is solidified because, despite
the changes over the thirty years, the top-level is composed of the same
long-standing members with few renewals.

\subsection{The Community Ecosystem}

As mentioned in Section~\ref{sec:glrresult},
Figure~\ref{fig:ecosystem_map} and Figure~\ref{fig:ecosystem_map_2} focus on
elements of the Linux community, an ecosystem composed of legal persons (\textbf{foundations} and
\textbf{companies} from a variety of IT markets) and natural persons, i.e., \textbf{people}
(users, developers, coordinators, writers). From GL materials, it is possible to
verify that each entity has a particular interest in participating in the
community to support and influence the project development.

\subsubsection{Foundations}

Foundations participate in the Linux project to \textbf{support the
development community}. To this end, foundations promote related projects and code
improvements, produce informative materials, and mediate internal and external
conflicts. Foundations also participate in the \textbf{project governance} and
some of them employ senior developers. Consequently, conflicts of interest
became a concern when foundations employ some top-level maintainers and also
receive money from corporations. On the one hand, corporation investments
provide financial support along with their commercial interest.
On the other hand, the top maintainers have voting power in the
project and guide the development. Therefore, governance and business
are intertwined and this model contributes to keeping the hierarchy and
privileges of the upper-cadre.

Authors also raise questions around specific characteristics of foundations'
subsistence that would \textbf{influence the development and management}.
These institutional characteristics include \textbf{source of income}
(who finances their work), \textbf{members} (how its members and board are
composed), and \textbf{governance} (how they are organized and how they
manage the foundation).  They approach two prominent foundations in the Linux
kernel project: the \textbf{Linux Foundation} and the \textbf{X.Org
Foundation}; however, foundation participation is not restricted to them.
  
\subsubsection{Companies}

Companies in Linux development come from a variety of markets and are,
occasionally, competitors. They bring \textbf{users} and demands o the project.
They have different \textbf{interests} that vary from providing user support to
using the system as a resource for correctness guarantee and becoming more
competitive. They contribute to the source code
mainly by \textbf{employing developers} and their code contributions are identified by
the developers' e-mail domain or information on the code submitted.

A company could develop in-house new contributors, but also employ \textbf{maintainers} and
active contributors that already participate in the process of review and
acceptance of code changes. In this sense, employing Linux maintainers could
bring some practical facilities for a company, such as clearing maintainer
bottlenecks and influencing areas of contributions over a subsystem.

Companies often give some freedom in how employees do the work; however,
the work's scope is limited by the company's market interests.
Employers are primarily looking for \textbf{investment return} and,
consequently, pay developers to work on things that bring value to their
business. Therefore, despite developer-employees have a large portion of
the total code change in each kernel version, the \textbf{nucleus of
contributions} is around their company's hardware and little in Linux
core needs, such as core components and project documentation.

\subsubsection{People}

\textit{``The Linux community is a pyramid''}~\citep{lf_blog}.
The Linux kernel community is hierarchically structured both from the general
contributors' perspective and from the code development perspective.
People are organized in a \textbf{pyramidal structure},
where a large portion of the community of general
contributors comprises \textbf{users, testers, and sysadmin}. In the mid-level, we
find Linux-based \textbf{distribution developers} that are, in practice, end users.
\textbf{Active developers} and \textbf{maintainers} are at the top, shaping the system.
Maintainers have commit rights and work as leaders, but a large portion of
coding is made by developers without commit-rights. They range
from the most active to one-time contributors who change the source code by
\textit{``submitting patches to maintainers who will, in turn, commit those
patches to a repository and push them upstream to higher-level
maintainers.''}~\citep{lwn_movemaintainer}.

The hierarchical organization is not new.
It is present in different structures
that composed the Linux kernel development model and is supported by the git
version control tool. In fact, the project management responsibilities looks like a tree. From
Linus Torvalds (and from Greg Kroah-Hartman in some contexts), the development
coordination starts to branch in maintainers and developers as leaves. Also,
the source-code is hierarchical and distributed in many repositories and work
trees. Finally, the community roles is organized in levels of participation and
also permission rights and privileges that resemble a tree.
Hence, the hierarchy models the kernel source, the development process, and also the code development community.

Looking inside the code development community, the \textbf{hierarchy is steeper}.
The upper-cadre has a top
leader with abusive and disrespectful behavior, and the source code is divided
into lots and distributed to a small group of maintainers responsible for
coordinating work on that slice.
In community publications, some individuals claim that the kernel development
community is led by a \textbf{`benevolent dictator'} -- Linus Torvalds. He establishes policy and
integrates contributions from all subsystem branches. Strengthening the idea of
subordination, a small group of maintainers is below him. 
For example, in 2014, Jonathan Corbet published an article on the web magazine
LWN~\citep{lwn_linushappy} starting with
\textit{``Any self-respecting development community should be attentive to
the needs of its benevolent dictator''}, bringing a firm idea of subservience.

According to publications, git supports this benevolent dictatorship
model, encouraging branching and embracing the chaos of allowing developers to
code what they are interested in solving. Linus Torvalds is mostly a
tie-breaker, and \textit{``the tie-breaker role tends to trickle down to other
experienced project members even before a benevolent dictator steps
down''}~\citep{lwn_devmodel}.

\btul{Interactions}

The \textbf{means of interactions} can also change between those who are or are not part of
the upper-cadre. To meet in person, developers participate in \textbf{conferences}.
Face-to-face meetings brings \textbf{community relation benefits} since members
see the faces behind e-mails. Also, conferences help newcomer engagement and sharing
experience, ideas, and problem/solutions between different projects.
However, some conferences are only addressed to a select group of
maintainers, such as the Kernel Summit conference and the Maintainers Summit.
These conferences may be seen as private venues
to shape the project development, i.e., a \textbf{no-public decision-making
forum} where discussion, decision-making, and voting take place.
, \textit{``A traditional
Kernel-Summit agenda item was a slot where Linus Torvalds had the opportunity
to discuss the aspects of the development community that he was (or, more
often, was not) happy with''}~\citep{lwn_statelinus}. 
The meaning of this slot is questioned in another grey document, arguing that
\textit{``feedback sessions about maintainer happiness only reinforce the
control structure, with, e.g., the kernel summit featuring an `Is Linus happy?'
session each year.''}~\citep{danvet_maintainers}

While there are opportunities to meet \textbf{in-person}, development community members mainly interact \textbf{remotely}. \textbf{Mailing-list}
is a well-known channel where collaboration takes place. Members from different
companies collaborate in \textbf{interaction nucleus}, proportional to their
companies interest. They are more likely to collaborate with others from the
same companies or companies in the same market. Another nucleus is people that
recently sent a contribution or were working on the same area of code. Finally,
\textit{``someone is more likely to reply to a
maintainer''}~\citep{opensource_com}.
This corroborates one of the motivations for the multiple-committer
maintainership model, the fact that \textit{``Patch submitters wanted to deal
with the maintainer rather than with other
reviewers''}~\citep{lwn_group_maintainership}.

Discussions occur \textbf{asynchronously} per patch and per subsystem. The
members are from different companies and \textbf{time zone differences} are not
an issue. Besides, members keep track of key collaborators' time zones when
expecting replies, and similarities in the timezone do not strengthen this
interaction. Because it is textual, e-mail interaction can exibit a \textbf{lack of
tone} and, besides code acceptance, it brings \textbf{social aspects}
like misunderstandings, hurt feelings, and frustration.

Another means of interactions very present in some subsystems development are
\textbf{IRC channels}. Because it is also textual, conversations on IRC carries the same
social problems of disagreements that could look scary for outside viewers and
newcomers. Unlike the mailing-list, IRC interactions suffer from timezone
differences.

In fact, social aspects in the Linux community influence the quality of
communication. Many community members consider the \textbf{discussion culture}
positive for the project, where long arguments in flame wars are an essential
part of fixing bugs. However, with members distributed geographically and
coming from different cultures, communicating is \textbf{context-dependent} and,
therefore, members should be careful in the tone adopted to express an opinion.

\subsubsection{Developers}

Some contribute to the Linux community by spreading the project's practices and
recruiting new contributors, such as \textbf{book/article authors} and
\textbf{internship programs coordinators}. However, the kernel developers are
those who change the system code.

\textit{``The
kernel development community is organized as a hierarchy, with developers
submitting patches to maintainers who will, in turn, commit those patches to a
repository and push them upstream to higher-level maintainers''}~\citep{lwn_patchflow}.
The maintainership model is also evolving as the project grows, and \textit{``the hierarchy
shows more clearly than it has in past years. A number of subsystems are
growing to the point where there needs to be some overall higher-level
coordination. So there are more two and three-level trees than there used to
be''}~\citep{lwn_patchflow_2017}.

If one day the development of Linux was portrayed as a product of volunteers
and enthusiasts looking to solve their personal problems with the system
anarchically, this has become a very distant reality. \textit{``Today, over 90
percent of the code is coming from professional developers who are employed by
some company to work on the kernel''}~\citep{lf_devreport2017},
and professionalism is a trend reinforced by the community.

\btul{Identity}

Based on Linux community publications, \textbf{common characteristics} of a
typical development community member is professionalism and discipline. They
have diverse backgrounds and are in different locations, working for different
companies. On the one hand, Linux developers have a professional and friendly
relationship. On the other hand, many do not know each other personally and
only "meet" by email or online communication platforms.

Volunteer work is a negative trend in Linux development. The number of contributions
from volunteer developers has decreased with each version of the kernel. Active
developers report that working on the Linux kernel is a massive career
boost. It leads volunteers to be hired quickly, giving them a good
\textbf{paycheck}. The community claims this is a
result of open-source professionalism. Most kernel developers are
affiliated with some organization, such as foundations, tech companies, or
consulting. However, they do not always link their contributions to the company
that pays their salaries. Consequently, in addition to changing the email
domain according to the company \textbf{affiliation}, they can switch between their personal and
company email addresses.  Moreover, \textit{``developers who
work on independent projects tend to think of themselves as affiliated with the
project first, and their employer second; that results in a strong incentive to
avoid compromising the project's goals in favor of what today's employer
wants''}~\citep{lwn_linux25}.

\btul{Motivation to stay}

Active kernel developers have different reasons to stay; however, their
motivations converge with the Linux kernel project's unique power in the IT
market and career opportunities. Developers continue to work on the kernel for
\textbf{professional} interest, such as paycheck, career boost, and direct interaction with the system users. They
are also in search of \textbf{technical inovation} from a cutting-edge
operating system: learning new things, getting new ideas, and keeping improvements
due to high-level technical collaboration. Finally, but as important as the
previous ones, they have \textbf{personal motivations} to participate in the
community. The variety of Linux usage keeps them never bored -- they have fun
and meet new people. They also believe their talent is recognized there. And some
of them are there for their belief in FLOSS.

%\newpage %%

\btul{Roles}

Developers might have a specific role in the Linux kernel community. This role
gives to someone priviledges on accepting and committing changes to the source
code. In general, the developers should climb a \textbf{path of contributions
in the community} to acquire a prominent and recognized position. However, the
closer to the upper-cadre, the less meritocracy affects -- since top-level
developers have a reputation, an assumed trust, and generally more coordination
than coding activities.
The community has an organic influx of \textbf{contributors}.
These \textbf{newcomers} get involved in the
development through \textbf{internship programs}, \textbf{in-house company}
trainings, or just \textbf{volunteers}.
Regardless of the gateway, they deal with a steep learning curve
that requires endurance and enjoying the project. From the community members'
perspectives, newcomers should have time to learn and synthesize change. Good
\textbf{start points} are small contributions, such as documentation, patch review,
testing, and reporting bugs. For coding contributions, they cited bug fixing as the fastest way to get started.
If they start from an internship program (as Outreachy), mentors commonly
require knowledge of debugging, git, static code analysis tools, patch submission, driver
implementation, and the subsystem structure.

Contributors develop code changes, but only \textbf{maintainers} feed the mainline. They
maintain a \textbf{slice} of the source code that can be a subsystem, distro kernels,
stable release, drivers, or a framework. They are hired by companies with a
market interest in the slice they maintain. They accumulate a series of
\textbf{attributions}, from management and quality assurance to training and coding.
To feed the upstream with patches, maintainers must gather and manage
patches, deal with outstanding issues, as well as review patches. This clerical job needs technical
effort and consumes part of their time.

Maintainers should also \textbf{concern} about how to lead a team of people, guiding or mentoring developers,
coding, and documenting features and procedures. \textit{``It’s About the
People. If you’re maintainer of a project or code area with a bunch of full
time contributors (or even a lot of drive-by contributions) then primarily you
deal with people. Insisting that you’re only a technical leader just means you
don’t acknowledge what your true role really
is''}~\citep{danvet_maintainers}.
Due to their mediator position, maintainers must ensure a balancing act of
keeping developers engaged while asking for change or rejecting a contribution.
In the meantime, they must prevent failures and regressions in their subsystem,
carrying the fear of being publicly censured.

In a subsystem, maintainer adopt a suitable \textbf{maintainership model} to sustain
daily project activities. Selected documents mentioned three \textbf{approaches}:
single-maintainer, co-maintainer, and multiple-commiters. A \textbf{single-maintainer}
works alone, being the only one with commit-rights in the related subsystem repository.
Co-maintainer differs from a single one by the number (two).
Although most subsystems \textbf{adhere} to the single-maintainership model, the workload on
some subsystems requires more people to handle the work. These subsystems
already count on proactive developers' feedbacks and patch reviews. To prevent
maintainers from burning out, they spread acceptance permission in a
\textbf{group maintainership model} of two \textbf{co-maintainers} or \textbf{multiple-committers}.
Their \textbf{motivation} is to find a robust approach in case of a position vacancy and an
effective way to develop new maintainers for the future.
Also, as fear is not a bottleneck for changes, this model fosters new
contributors and contributions.

Few subsystems have a group of maintainers, but the number is increasing.
From publications, we identified three models of group maintainership with the following \textbf{general features}:

\begin{itemize}
	\item \textit{Hands-off:} Maintainers share a single repository and a
		log file of actitivies. They use an IRC channel to take a
		``lock'' to apply some changes.
	\item \textit{Delegation:} The work is automatically delegated using the
		Patchwork patch-management system. Patchwork sorts changes as
		they arrive and handles each patch to a specific maintainer.
	\item \textit{Multiple-commiter:} Many committers have the ability to
		commit changes to the repository; however, maintainers and
		committers have different responsibilities. While a commiter
		works internally and is not listed on the MAINTAINERS file; a
		maintainer has external visibility, dealing with the rest of
		the world and accepting the blame when something goes wrong.
\end{itemize}

In both single and co-maintainership models, contributors avoid disagreements
with the maintainer since they have only one or two ways to have their
contributions accepted. To improve the patch acceptance process, the
multiple-committer model emerged in a subsystem with few maintainers and many
reviewers. They have observed that code submitters want to deal with
maintainers, and this need for a maintainer answer became a bottleneck — only
one subsystem reports to use this model. As with the other models, it also
presents specific \textbf{challenges and requirements} to works correctly.
The multiple-commiters model needs a consistent team of
developers staying around, and non-maintainer reviews must be the norm to work
efficiently. Also, to ensure code quality, committers need to perform useful
pre-commit tests and resort to good documentation and tools.

In the maintainer pool, there are also the top-level maintainers, a role filled by
\textbf{senior developers}. Although most maintainers are employers of a small group of
large companies, top-level maintainers are commonly paid by a foundation. They
are in singular positions not related to a particular subsystem and almost
unavailable for disputes. Their role involves fewer patches and is focused on
management and review. Linus Torvalds is at the absolute top and holds the
single role to manage the mainline repository and merge pull-requests from all
subsystems.  \textit{``When asked about group maintainership at the top level,
he said that he is open to the idea, but doesn't think that there is a lot of
need for it.  He manages to be responsive, even when he's off diving in some
remote part of the world''}~\citep{lwn_statelinus}.

\subsection{Community Concerns}

As expected for a software development project, developers keep an eye out for
\textbf{technical issues} of code cleanup and standardization, elimination of errors,
security/vulnerabilities, and documentation quality. For example, contrary to what is
acclaimed by ``Linus' law'', having enough eyes has not been sufficient for the
current security process. \textit{``If we were able to fix problems as quickly
as we like to think, it would still be insufficient; it is increasingly clear
that patching things up after somebody discloses them is not enough. But,
sometimes, problems seemingly slip through the cracks and are not fixed
quickly, even when they are known''}~\citep{lwn_pathfix}.

However, community publications also bring emergent information and
ongoing issues from the social perspective that affect collaboration and the
current development model.\textit{``The technical issues have been small
compared to the social challenges involved in organizing a project largely
consisting of volunteers at first, and then kernel developers paid by companies
with competing interests, operating in disparate markets with vastly different
computing needs''}~\citep{linux_reflect}.

\subsubsection{Social challenges}

Communication and interaction between members face common social challenges, such
as determining the boundary between acceptable and inadmissible conduct,
finding mechanisms to identify abusive behaviors, and sensitizing them to cultural
differences to prevent disrespectful actions.
\textit{``The community likes to
think that its decisions are based entirely on merit. In truth, there is also
an important social element involved in working in the development community.
Despite our efforts to just review code and judge it on its own merits, there
are personalities involved. As a result, we see snippy answers and negative
things happening in our communication channels''}~\citep{lwn_perspective}.

\btul{Conduct issues}

Remote interaction and textual \textbf{communication in mailing-list} pose challenges to the
collaborative development process. 
Some \textbf{negative behavior} is explicit in
the use of an \textbf{innapropriate language} with profanity and cursing; however, impoliteness and irony are subject to cultural
diversity. Participants of the 2018 Maintainers Summit
conference~\citep{lwn_codeconduct} reported that
messages such as \textit{``I love your patch''} from the 0day robot, an automated Linux kernel test service, could
be offensive and direct criticism could raise a strong feeling of shame.
Maintainers should not attack and be more careful to avoid inappropriate
communication.

A common concern reported by participants and observers is related to the
governance model of the Linux kernel, which gives Linus Torvalds enough
power to sustain his \textbf{offensive behavior}~\citep{linus_shame}.
Selected documents describe his rude and aggressive
reputation, and some members report that his controversial behavior has hurt
and drove away developers. Nevertheless, \textbf{active-developer resigners} do not
restrict the ``toxic'' working environment to him, reporting it in various
high-profile people's behavior. Unsatisfied with the development process or
community norms on mailing-lists, few make noise when deciding to step down.

The conduct of community members is an \textbf{ongoing issue}. The longstanding \textbf{Code of
Conflicts} was no longer efficient to prevent negative behaviors. Even worse,
the Code of Conflicts acculturated \textit{``no-filter feedback and bluntness as the natural and
more successful state of open source software
development''}~\citep{linus_return}.
During the term of the Code of Conflicts, only three conduct issues were
reported to the \textbf{Linux Foundation Technical Advisory}, and all of them had
weak substance.

After a self-imposed short break from the Linux
development~\citep{torvalds_2018}, Linus Torvalds
replaced the Code of Conflict with a \textbf{Code of
Conduct}\footnote{\url{https://www.kernel.org/doc/html/latest/process/code-of-conduct.html}}
in an attempt to avoid losing talents and an answer to a magazine article
questioning his conduct on public mailing-lists~\citep{newyorker}. The Code of Conduct was
presented as a \textbf{symbol of the community conduct goal} to continue to scale,
remain a welcome place, and convince the outside world that the community has
gotten better. It is a consequence of the progress toward civility and
professionalism in the Linux kernel community.

The code was \textbf{based on Contributor Covenant Code of Conduct}\footnote{\url{https://www.contributor-covenant.org/}}, which other projects are used but is not
widely accepted by the community. Its adoption was inspired by the DRM
subsystem's successful case of conduct, based on the freedesktop.org code. The
code was reviewed by Lawyers of the Linux Foundation and, in case of conduct
incident, someone should report to a Code of Conduct Committee, composed of
volunteer members of the Linux Foundation Technical Advisory Board and a
professional mediator.

Despite impacting all community members, the code was initially \textbf{built in
private}, without a community-wide discussion. Members complained that the
\textbf{adoption process} was hasty and did not follow the open-source model, and the
acceptance does not happen in a public manner but through hidden e-mails. Also, when
published, it was first presented for a group of maintainers. This group raised
several questions about the application of norms and the maintainer's
responsibilities on that. Linus Torvalds clarified that maintainers are not
police and should lead by example, and the group asked for additional
interpretation documents\footnote{\url{https://www.kernel.org/doc/html/latest/process/code-of-conduct-interpretation.html}}.

Again, questions about the Code of Conduct present in some publications reveal
how interaction problems in the Linux kernel community are similar to the other
social groups.\textit{``Such laundry lists of misbehavior can leave a bad taste
in the mouth; that can be especially true if, like me, you are an older,
run-of-the-mill white male; it is easy to look at a list like that and say
everybody is protected except me'. It can look, rightly or wrongly, like a
threatening change pushed by people with a hostile agenda''}~\citep{lwn_codeconflict}.

\subsubsection{Process Issues and Challenges}

In 1998, Linus Torvalds merged some incomplete frame buffer patches to the
2.1.123 release, which caused a compilation failure in the Linux kernel. That
served as a trigger for some members disappointed with the Torvalds' manner
to handle patches. This episode became known as the ``Linus burnout'' and shed
light on \textbf{scalability issues} in the Linux development
model~\citep{lwn_scalelinus}.
The Linux kernel project has been growing steadily. Since all contributions'
endpoint is the mainline repository, and the version's release is centered on
Linus Torvalds, the ``Linus not scales'' problem still permeates the community
discussions.

\textit{``Process scalability requires a distributed, hierarchical development
model''}~\citep{lf_devreport2017}.
Because of this, the Linux development model has undergone some transformations
supported, basically, by the adoption of version control tools -- Bitkeeper and
later Git -- and by the hierarchical structure of maintainers. These smoothed
the release process dependence on Linus availability and increased the volume
of patches he could handle. \textit{``Without the right tools, a project like a
kernel would simply be unable to function without collapsing under its own
weight''}~\citep{lf_devreport2017}.

Now, other nodes in the development process seem saturated. Through
publications, the community points out the challenges in the
\textbf{maintainership scalability} and the patch acceptance and \textbf{review process}. In addition
to tools to support the release cycle process, the community claims for more
documentation and automation of the contribution flow daily tasks, expressing concerns
with the project's continuity as the community is \textbf{getting older}.
The community publications present substantial guidelines, supporting tools and
online materials, and \textbf{internship programs} to \textbf{attract new and young people}.
However, after three decades, they are now facing problems of a matured,
long-life project. The upper-cadre is aging, and maintainers are also not
self-motivated to find people able to substitute them in case of vacancy.

Hence, in spite of the interest in attracting outside developers, the community
currently turns part of its attention to find mechanisms able to retain and
\textbf{grow the existing contributors}. It needs contributors to replace or scale roles
important for the project workflow, like maintainers and reviewers. The
capacity of reviews must grow, and maintainers show \textbf{signs of stress}; therefore,
developers other than the maintainer should be available and included in the
review process.
More reviewers, as well as \textbf{mid-level maintainers}, would reduce the
maintainership workload. Many maintainers have limited time working on a given
subsystem, and the situation worsens as the subsystem grows in size. A
non-proportional number of developers can overwhelm their work, leading them to look
for another job. A burnt-out maintainer is also more likely to ignore or reject
new ideas and give short and unclear answers. 

The concern around scaling the number of maintainers increases as the number of
subsystems is growing. This growth requires higher-level coordination, two and
three-level trees, and, consequently, the progression of developers in maintainers. The community
claims for documentation and automation to avoid \textbf{knowledge retention} and make
more friendly and \textbf{inclusive processes} to both new contributors and developers
already part of the community.

Standardizing the process can also avoid the \textbf{patch acceptance double standard}.
The probability of merging a patch increases from newcomers to the
long-term contributor and contributor commits to maintainers self-commit.
Maintainers have implicit assumptions and rules and use checking and testing
tools unavailable to developers. Some maintainers \textbf{resist changes in the
development process} because they fear losing privileges. By retaining knowledge
and requesting proof of subordination from those who need the approval to move
on, they turn the patch acceptance process into a superior power exercise that
complements their toxic behavior.

The results obtained from the strategies selected for the grey literature
review on the Linux kernel project reinforce the relevance of examining FLOSS
community publications. Grey literature is a rich source of data to define key elements and accurately describe
the subjects of a FLOSS project development model. Besides mapping roles, rules,
structures, and mechanisms of the distributed, community-based Linux kernel
development, our investigation reveals current community concerns that can
affect the project's survival. Therefore, we advanced our investigation to
assess the coverage and pace of academic research and day-to-day development
issues in the Linux kernel project. In the next chapter, we present the results
of systematically review academic studies, the evaluation of adherence to
academic and grey literature concepts, and discussion findings from a
participant observation in the Linux kernel community.
